/** 
 *   FIXME ....
 *
 *   (c) Copyright 2003 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ???
 **/

#include <stdio.h>
#include <stdlib.h>
#include "encoders.h"
#include "iar.h"
#include "anemometer.h"
#include "coordinate.h"


int main(int argc, const char *argv[]) 
{
	struct encoders_data ed;
//	int ra = RA_CASE;
	//int dec = DEC_CASE;

	int ra = DEC_CASE;
	int dec = RA_CASE;

	int val_anem;
	int ra_old, dec_old;
	int ra_factor, dec_factor;
	int ra_val, dec_val;
	if (encoders_open(ra, dec) == -1){
                perror("main");
                exit(1);
        }
	printf("The bufer legent is %d\n", encoders_buff_len());
	printf("e5850 is running: %d\n", encoders_is_running());
	//encoders_clear_buff();
	//getchar();

	ra_old = dec_old = ra_factor = dec_factor = 0;

	while(1) {
		if (encoders_get_raw_data(&ed) == 1) {
			val_anem = get_anemometer();
			ra_val = diff_evaluate(ra_old, ed.encoder[ra],
					       &ra_factor);
			dec_val =  diff_evaluate(dec_old, 
						ed.encoder[dec],
						&dec_factor);
			printf("%5d (%6.4f) %5d (%7.4f) %3d\n", 
			       ed.encoder[ra],  ENC2DEG(ra_val),
			       ed.encoder[dec], 
			       -ENC2DEG(dec_val) /* + IAR_LATITUDE */,
			       anemometer_conv(val_anem));
			ra_old = ed.encoder[ra];
			dec_old = ed.encoder[dec];
		}else{
			printf("The bufer legent is %d\n", 
			       encoders_buff_len());
		}
	}
	
	encoders_stop();
	printf("e5850 is running: %d\n", encoders_is_running());
	
	encoders_close();
	
	return 0;
}



